
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何搭建亿级社交信息分享平台？ / iVAN</title>

    <meta name="description" content="如何搭建亿级社交信息分享平台？ 由于移动互联网的兴起,人与人之间的交流.信息分享能够以电子信号的速度传递在各个终端设备之间,每个人也都能够成为一个信息发布平台和信息接收平台,像朋友圈.微博.Twitter等社交平台的出现,大大方便和丰富了人们的日常生活.人人分享.人人参与也必然要求社交平台能够具有大规模.高并发.低延时的能力.通过本文,我们来看看如何搭建一个能够承受亿级活跃用户的社交信息分享平台. 一个最基础的方案 我们先来定义一个社交平台的基础的功能: 用户能够发布自己的状态.心情.照片.小视频等信息 用户能够关注自己的朋友">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何搭建亿级社交信息分享平台？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>由于移动互联网的兴起，人与人之间的交流、信息分享能够以电子信号的速度传递在各个终端设备之间，每个人也都能够成为一个信息发布平台和信息接收平台，像朋友圈、微博、Twitter等社交平台的出现，大大方便和丰富了人们的日常生活。人人分享、人人参与也必然要求社交平台能够具有大规模、高并发、低延时的能力。通过本文，我们来看看如何搭建一个能够承受亿级活跃用户的社交信息分享平台。</p>
<h2>一个最基础的方案</h2>
<p>我们先来定义一个社交平台的基础的功能：</p>
<ol>
<li>用户能够发布自己的状态、心情、照片、小视频等信息</li>
<li>用户能够关注自己的朋友、大V、明星等，时刻查看社交圈内的最新状态</li>
</ol>
<p>为了满足这个最简单的需求，除了最基础的用户信息表，我们还需要添加用户关注表以及状态发布表：</p>
<pre><code>// 用于记录每个用户关注的朋友、大V、明星等人物信息
CREATE TABLE Followers(
    user_id VARCHAR(20) NOT NULL,
    --关注人id
    attention_id VARCHAR(20) NOT NULL,
    --备注
    remark VARCHAR(100),
    PRIMARY KEY(user_id, attention_id)
);

// 用于记录每个状态的发布信息
CREATE TABLE Information(
    message_id INT NOT NULL AUTO_INCREMENT,
    --发布人id
    user_id VARCHAR(20) NOT NULL,
    --发布时间
    posted_time INT NOT NULL,
    --发布内容
    content VARCHAR(20) NOT NULL,
    PRIMARY KEY(message_id)
);

</code></pre>
<p>然后每个用户在刷新自己的朋友状态时，后台可以使用如下的 SQL 来获取信息：</p>
<pre><code>SELECT message_id, poster_id, posted_time, content
    FROM
    (   SELECT user_id, attention_id
        FROM AttentionInfo WHERE user_id=5
    )user
    JOIN
    (   SELECT message_id,user_id as poster_id,posted_time,content
        FROM Information
        WHERE posted_time &gt; ${上次刷新时间}
    )message
    on user.attention_id = message.poster_id
    order by posted_time desc
    limit 10;
</code></pre>
<p>好了，当有好友更新了状态，用户马上就可以通过刷新看到了。</p>
<p><a href="https://yqfile.alicdn.com/c395e2f43173953b2620cae39ac4d794fb2fd6b1.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2MzOTVlMmY0MzE3Mzk1M2IyNjIwY2FlMzlhYzRkNzk0ZmIyZmQ2YjEuanBlZw==.jpg"></a></p>
<h3>挑战</h3>
<p>这个设计在用户数量较小的时候是没有问题的，随着业务的成熟，不管是用户数量的增加还是历史状态数据的积累，我们都会面临如下几个挑战：</p>
<h4>1.并发</h4>
<p>状态的发布和分享功能是社交平台的核心功能，几乎承担了社交平台95%以上的读写访问量，单个数据库已经无法承担所有用户的访问并发了。</p>
<p>这时候我们可以采取的是将状态发布表按照用户也就是发布人进行拆分，假如将所有的用户按照哈希分成10份，每一份对应一个新的数据库，这样理想情况下，每一个数据库只需要支撑 1/10 的读写并发，也就是能够支持现在10倍的用户量。</p>
<p>但从并发这个问题上来看，分库分表可以解决这个最棘手的问题，我们再看看下面几个挑战。</p>
<h4>2.性能</h4>
<p>关系型数据库的访问性能与表中数据的大小是有直接关系的，同样的查询场景，数据量越多，访问性能也就越慢，跨表的JOIN查询受影响更为明显。</p>
<p>分库分表可以将数据量打散，维持住单库或者单表的数据量上限，但是当一个用户的关注人被路由到了多张子表或多个子库之后，单个用户的社交圈刷新会发起跨库的查询事务，一方面让查询逻辑会变的更加复杂，跨的子表或者子库个数到一定数量之后，反而查询性能会更慢；另一方面，跨子库子表的查询也加剧了每个子库或者子表的访问压力，最坏情况下，每个用户的刷新动作都会查询所有的子表或者子库，这样又与分库分表的初衷相悖了。</p>
<h4>3.稳定</h4>
<p>当活跃用户量上来之后，为了应对高并发的访问和保证低延时的性能，分库分表又好像是唯一的方法。子库子表的个数越多，管理的代价和复杂度也会越来越大，任何一个子库所出现访问热点会影响整个服务，而一次分库分表会需要极高的运维代价，停服停写、重新设置路由规则都会让这种实时在线服务的稳定性异常脆弱。更不用说服务器磁盘故障甚至是宕机了，如何保证业务的稳定也会是一个大大的问题。</p>
<h4>4.成本</h4>
<p>好了，假设我们使用一个良好的方案解决了并发、性能以及稳定性上的问题，服务运行良好，往往这个时候业务也度过了野蛮生长的时期，下面就是要考虑成本了。</p>
<p>我们也发现社交平台上的用户活跃时间段有着明显的规律性，比如一日三餐的时段，比如周末，比如节假日，再在比如有重大活动的时候。在2016年除夕当天微信红包收发总量80.8亿，共有4.2亿人参与，平均每人收发20个，而在年初一凌晨00:06:09，一秒钟发送的红包数量达到了40.9万个。</p>
<p>对于社交平台而言，高峰时段的并发访问量可能比一般的时段高出了一个甚至是多个量级，如果按照高峰时段来准备硬件资源将会产生非常大的浪费。</p>
<p>那么我们就需要一款大规模、高并发、低延时同时又能够弹性资源按量付费的数据库产品了！</p>
<p>按照上述需求，我们找到了阿里云的表格存储。</p>
<p>表格存储是一款能够提供单表PB级以及百万TPS能力的NoSQL数据库服务，服务端自动对数据进行分区和负载均衡，让单表数据从 <strong>GB</strong> 到 <strong>TB</strong> 再到 <strong>PB</strong>，访问并发从 <strong>0</strong> 至 <strong>百万</strong> 都无需繁琐的扩容流程，按量付费又避免了访问低谷时空闲资源的浪费。对象存储提供了 <strong>近乎无限大小的存储空间</strong> ，数据的增量无需任何扩容流程。</p>
<h2>架构设计</h2>
<p>我们将用户关注的信息、发布的状态、照片视频的缩略图等存放在表格存储中，利用表格存储的高并发低延时的特点，在极短的时间内展示出最新的状态、照片等信息，将照片、短视频的源数据存放在对象存储中，通过CDN加速，在用户点击照片或者打开视频时，照片、视频通过CDN加速迅速在设备端进行加载， <strong>这样既大大提高了用户体验，又很好的节省了不必要的数据传输。</strong></p>
<p><a href="https://img.alicdn.com/tps/TB1XH5BOFXXXXbsXpXXXXXXXXXX-885-247.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2ltZy5hbGljZG4uY29tL3Rwcy9UQjFYSDVCT0ZYWFhYYnNYcFhYWFhYWFhYWFgtODg1LTI0Ny5qcGc=.jpg"></a></p>
<h2>方案实现</h2>
<h3>移植原连接查询方案</h3>
<p>表格存储目前只提供SDK及API操作，还不支持 SQL 语句查询，而目提供的Hive、SparkSQL的查询方式主要偏向于离线分析场景，无法满足实时在线查询的需要,上述的跨表JOIN查询需要通过API来实现，当用户查看社交圈的最新状态时：</p>
<p>1.先从关注表中拿到所有的关注信息</p>
<p>2.调用 BatchGetRange 拿到所有关注人的新状态</p>
<p>3.对拿到的状态信息根据发布时间进行Merge，然后在客户端进行展示</p>
<p>4.记录此次查看的时间，用于下次刷新</p>
<p><a href="https://yqfile.alicdn.com/05a7c543557dcb58932bc09eda96074e9b4698a7.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzA1YTdjNTQzNTU3ZGNiNTg5MzJiYzA5ZWRhOTYwNzRlOWI0Njk4YTcuanBlZw==.jpg"></a></p>
<h3>挑战</h3>
<p>虽然使用表格存储之后不再需要关心并发、性能、稳定和成本这些头疼的事情了，但是我们也发现这种方案对业务层的服务端有着很高的要求，为了达到极致的用户体验，用户的每一次刷新我们都需要起多个线程进行并行的 GetRange 查询，再在服务端按照发布的时间进行 Merge，并发的线程越多，用户体验到的延时也就越短，但是服务端的压力也就越大，多次联合查询能够提供的性能都是有极限的，关注的人物越多，刷新的效率也就越低。</p>
<p>如何能够提供一个真正达到极致的用户体验的社交平台呢？</p>
<p>基于表格存储我们不用再考虑规模、并发、性能等等方面的问题，那该如何设计呢？</p>
<h3>一个新的方案</h3>
<p>在系统的架构设计上，越复杂的系统，需要做的tradeoff也就越多，为了达到极致的用户体验，我们可以考虑牺牲状态的强一致性，不再要求一个状态在发出后能够马上被所有的用户看到，主要有两个原因：</p>
<ul>
<li>大部分用户对状态的时效性的要求并不是强一致性的，秒级的延时为大家所接受</li>
<li>在针对海量用户的方案设计上，保证状态的强一致性也基本不可能，事务的隔离级别和数据库并发性是对立的，隔离级别越高，数据库的并发性也就越低，这也导致了无法保证状态信息的强一致性</li>
</ul>
<p>基于这个前提下，我们将每个用户都作为一个 Session，其关注的所有状态都写入这一个Session内，那么用户在查看自己社交圈的更新时，只需要查看自己的这一个 Session 中新的状态即可。</p>
<p>我们使用一张新的 <strong>状态分享表</strong> ，以用户的 <strong>user_id</strong> 为分区键，状态的 <strong>发布时间</strong> 为第二个主键，状态发布及查看流程如下：</p>
<p>1.用户在发布状态时，将状态写入到该用户所有粉丝的 Session。</p>
<p>为了能够应对突发的写入流量，我们可以先将状态写入队列服务中，在后端异步将状态信息同步到所有的粉丝 Session内，当写入流量增加，我们增加后端的消费者就能够降低写入延时。</p>
<p>2.我们已将数据做了解耦，用户刷新自己的社交圈时，不再有其他的数据依赖，使用单次 GetRange 查询就能获取所需要的数据。</p>
<p>经过实测，表格存储的高性能实例一次读取连续的50行数据的平均延时也在20ms以内，完全能够满足设计需要。</p>
<p><a href="https://yqfile.alicdn.com/d7ff00c3919df078ed14d2610a89d1f004178fae.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2Q3ZmYwMGMzOTE5ZGYwNzhlZDE0ZDI2MTBhODlkMWYwMDQxNzhmYWUuanBlZw==.jpg"></a></p>
<h4>更多花样</h4>
<p>状态发布、朋友的最新状态查看都是社交圈最基础的功能，在这些功能之上还需要提供各种各样的小功能才能不断提高用户的粘性，比如新状态的推送、多平台信息查看状态的同步等等，这里不再一一详述，在高并发IM系统架构优化实践以及表格存储服务在社交应用场景的实践中，都有相关方案介绍，大家也不妨参考一下。</p>
<h3>结语</h3>
<p>表格存储天然支持单表PB级数据量及百万级的访问TPS，以及与基础数据量大小无关的访问性能，弹性资源和按量付费让业务在各个阶段都无需为不必要的资源付费。</p>
<p>把数据规模和高并发这些头疼的问题交给表格存储吧，需要快速迭代快速跟随用户需求优化的上层业务才是宝贵精力应该focus的地方！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 00:36:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ad%98%e5%82%a8%e4%b8%8e%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据存储与数据库">数据存储与数据库</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/aliyun/" title="aliyun">aliyun</a>, <a href="https://www.iamivan.net/tag/%e4%ba%92%e8%81%94%e7%bd%91%e4%ba%a7%e5%93%81%e5%8f%8a%e5%ba%94%e7%94%a8/" title="互联网产品及应用">互联网产品及应用</a>, <a href="https://www.iamivan.net/tag/%e9%ab%98%e5%b9%b6%e5%8f%91/" title="高并发">高并发</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e6%a0%bc%e5%ad%98%e5%82%a8/" title="表格存储">表格存储</a>, <a href="https://www.iamivan.net/tag/tablestore/" title="TableStore">TableStore</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何搭建亿级社交信息分享平台？的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKyGwWp.html" rel="bookmark">双12根本不在话下，阿里首次揭秘扛过双11的千亿级特征分布式机器学习平台XPS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里巴巴电商平台有上亿的用户和产品,每天产生百亿规模的用户反馈数据.比如淘宝首页的猜你喜欢场景,每天就有100亿规模的用户行为数据.如此超大规模的训练数据,给分布式机器学习带来了巨大的挑战,也引入了有趣的研究问题.2017年,阿里巴巴推荐算法团队和计算平台PAI团队合作打造了eXtreme Parameter Sever (XPS) 机器学习平台,其中eXtreme寓意为&quot;追求极致&quot;, 体现我们希望设计具有极致性能和效果的机器学习平台的愿景.XPS平台已经广泛全流量运行在手机淘宝的猜你			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlXQkOM.html" rel="bookmark">重庆建百亿级纱线电商平台</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重庆建百亿级纱线电商平台 随着越来越多的服装企业向中西部转移,重庆的服装业迎来了众多利好商机.昨日,南岸区政府与西材http://www.aliyun.com/zixun/aggregation/31946.html&quot;&gt;商品交易市场签订合作协议,双方将共同打造一个年交易额上百亿的纱线网上交易平台. 重庆西材商品交易市场是金考拉服饰有限公司打造的一个合资电子商务平台.金考拉服饰有限公司董事长.重庆西材商品交易市场董事长杨建明说,即将上线的纱线网上交易市场,是一种卖家对买家的直接出售模式,所有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQmGE8b.html" rel="bookmark">酷6网携手新浪微博打造视频社交化分享平台</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中国最具行业领导地位的视频网站之一酷6网,今日宣布与新浪微博达成战略合作.在新浪微博上,用户不仅能够观看.浏览.评论视频,此后还将实现自主视频上传功能.细心的用户已经发现,新浪微博登陆后,用户可以直接通过微博将视频上传至酷6网,实现与其他用户的实时分享与交流.此前,酷6网已与国内最大的白领SNS网站开心网以及国内另一分享交流平台网易微博实现深度合作,实现了视频上传.存储.分享等体验的一站式服务.在专注于UGC模式的同时,视频社交化战略又成为酷6网深化战略部署的重要一步.此次携手新浪微博,在微博入			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6NnJM.html" rel="bookmark">微软Sharepoint 2010企业信息分享的首选平台</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2001年诞生的微软SharePoint即将迎来自己的最新版本Microsoft SharePoint Server 2010 ,这款企业信息分享平台软件也从最初的门户建设发展成了及企业门户.信息分享.工作流管甚至是商务智能等诸多功能为一体的集成化平台.浩如烟海的功能让sharepoint一方面成为了企业信息分享的首选平台,但也让初次接触者一时无法理清头绪,不知道从何处着手去认识他. 拥有SharePoint 2007的经验能够帮助您更容易的理解本系列的文章,但我会尽量使没有SharePoint			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrQLAM.html" rel="bookmark">亿级用户下的新浪微博平台架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				亿级用户下的新浪微博平台架构 序言 新浪微博在2014年3月公布的月活跃用户(MAU)已经达到1.43亿,2014年新年第一分钟发送的微博达808298条,如此巨大的用户规模和业务量,需要高可用(HA).高并发访问.低延时的强大后台系统支撑. 微博平台第一代架构为LAMP架构,数据库使用的是MyIsam,后台用的是php,缓存为Memcache. 随着应用规模的增长,衍生出的第二代架构对业务功能进行了模块化.服务化和组件化,后台系统从php替换为Java,逐渐形成SOA架构,在很长一段时间支撑了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Nokxb.html" rel="bookmark">亿级App陌陌发力移动直播 率先拥抱视频社交</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				近日,移动社交应用陌陌更新至6.7版本,此次升级最重要的特点就是将&quot;直播&quot;功能提升到了主帧位置,替代了以前的&quot;发现&quot;帧.这使用户可以更便捷的看到陌陌直播上的视频内容,也意味着陌陌在国内用户过亿的社交软件中第一个全面推出视频直播功能,并期望以此为契机,全面探索视频社交的新玩法和新发展空间. 陌陌直播界面 陌陌于2015年9月推出陌陌现场,一款移动音乐互动直播产品,签约职业歌手,在有才华的艺人和粉丝之间搭建了一座互动的桥梁.同年12月,在陌陌现场初获成功的基础上,陌陌上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDendLb.html" rel="bookmark">亿级Web系统搭建：单机到分布式集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当一个Web系统从日访问量10万逐步增长到1000万,甚至超过1亿的过程中,Web系统承受的压力会越来越大,在这个过程中,我们会遇到很多的问题.为了解决这些性能压力带来问题,我们需要在Web系统架构层面搭建多个层次的缓存机制.在不同的压力阶段,我们会遇到不同的问题,通过搭建不同的服务和架构来解决. Web负载均衡 Web负载均衡(Load Balancing),简单地说就是给我们的服务器集群分配&quot;工作任务&quot;,而采用恰当的分配方式,对于保护处于后端的Web服务器来说,非常重要. 负载均衡			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAAE2eM.html" rel="bookmark">很不错的文章---【问底】徐汉彬：亿级Web系统搭建&mdash;&mdash;单机到分布式集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:很不错的文章---[问底]徐汉彬:亿级Web系统搭建--单机到分布式集群 [导读]徐汉彬曾在阿里巴巴和腾讯从事4年多的技术研发工作,负责过日请求量过亿的Web系统升级与重构,目前在小满科技创业,从事SaaS服务技术建设.  大规模流量的网站架构,从来都是慢慢&quot;成长&quot;而来.而这个过程中,会遇到很多问题,在不断解决问题的过程中,Web系统变得越来越大.并且,新的挑战又往往出现在旧的解决方案之上.希望这篇文章能够为技术人员提供一定的参考和帮助.  以下为原文 当一个Web系统从日访问量			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDeGZvb.html" rel="bookmark">&lbrack;转载&rsqb;亿级短视频社交美拍架构实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.短视频市场的发展 近几年来,短视频应用在国内应用市场引爆,美图公司推出了美拍,相关的产品还有 GIF 快手.秒拍.微视.逗拍.玩拍等,一系列短视频产品的出现也丰富了短视频应用市场. 短视频的相继爆发,与几个因素有关: 1.带宽,随着中国基础网络环境的发展,越来越多的2G移动网民开始转向使用 3G/4G 网络,从而体验到更好的上传下载带宽和更稳定的网络, 目前 3G/4G 的移动用户比例大概占比 85% 以上:同时随着资费的进一步降低,月户平均流量也达到了 360M,甚至不少部分是 GB 甚至			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKenOp.html" rel="bookmark" class="title">Photoshop金属效果的教程</a>
					<div>
						教程 1.新建文件,新建一个图层(lix有不在background上做东西的习惯),然后用钢笔工具锚出你所需要的外形,这里就用lix那个不知道什么东西的外形示范吧 2.把这个路径转成选区,填个比较深的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7dr4b.html" rel="bookmark" class="title">java中文解决大全&lpar;下&rpar;</a>
					<div>
						解决|中文 4.中文问题的分类及其建议最优解决办法     了解以上JAVA处理文件的原理之后,我们就可以提出了一套建议最优的解决汉字问题的办法.    我们的目标是:我们在中文系统中编辑的含有中文字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0k6Pb.html" rel="bookmark" class="title">让思维创新成为SEO行业的杀手锏</a>
					<div>
						我最近看新闻,发现各行业的竞争度也在不段增加,像电子商务.装修行业门户网站等等,这些行业都已经进入了冬季.然而SEO行业的普及也使这个行业进入了白热化了.我们如何才能在这样的困境下开辟一条新的道路,那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWkRmM.html" rel="bookmark" class="title">从网站文章原创谈决胜SEO的第一步</a>
					<div>
						最近看了一篇文章,大意是微博崛起,天涯失落.红红火火的微博颇为符合现代网友快餐阅读的习惯,从而很多混迹天涯的&quot;过客&quot;因为过多的关注博客,而疏远了天涯论坛.微博更新快文字难逃肤浅的弊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWL47p.html" rel="bookmark" class="title">让你的Windows 2000更安全</a>
					<div>
						Windows 2000系统的使用者特别多,导致在受攻击的系统中高居榜首,但这不是说Windows 2000的安全性一点儿不好,只要合理配置和管理有方,还是比较安全的.本人使用Windows 2000 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7YG3b.html" rel="bookmark" class="title">稳扎稳打Silverlight&lpar;2&rpar;</a>
					<div>
						稳扎稳打Silverlight(2) - 1.0实例之支持录音和回放的钢琴(Silverlight+ASP.NET AJAX+DLINQ) 示例 Piano.xaml(用Expression Blen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLVk3b.html" rel="bookmark" class="title">你变我也变&mdash;&mdash;Word中更新数据两法</a>
					<div>
						在办公操作中,常常遇到这种情况,文档已经输入完成时,某一个数值发生了变化,要将文档中所有 相同的数值也要进行改变.这时,我们虽然可以执行&quot;编辑/替换&quot;命令,将数值进行更新. 但这种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balYeXz.html" rel="bookmark" class="title">怎么使用PPT手工绘制日记本</a>
					<div>
						怎么使用PPT手工绘制日记本   一些关键的技术要点如下 1.绘制封底和纸张 深灰色角矩形+白色矩形形状效果设置成外阴影,营造立体感. 2.绘制锁边 圆+两条渐变线 本页为效果展示,下面有详细的绘制方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnlqnz.html" rel="bookmark" class="title">打印机实用技巧13条</a>
					<div>
						无论是激光打印机还是喷墨打印机,在普通操作者面前总是略显&quot;娇气&quot;,在操作过程中,要是稍微不注意的话,就可能出现这样或者那样的故障问题,这为我们高效使用打印机带来了不小的麻烦.我们只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wZAqp.html" rel="bookmark" class="title">excel保存和使用表格模板动画教程</a>
					<div>
						&lt;Excel2003入门动画教程33.保存和使用表格模板&gt;. 演示动画 保存表格模板 表格制作好了以后,执行&quot;文件→保存&quot;命令,打开&quot;另存为&quot;对话框 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZK74b.html" rel="bookmark" class="title">非法网站色情表演昼夜不间断一年吸金近2千万</a>
					<div>
						据中国之声&lt;新闻纵横&gt;7时40分报道,湖北荆州警方日前破获一起特大网上传播淫秽色情信息案:48位妙龄&quot;主播小姐&quot;三班倒,24小时进行视频色情表演,犯罪团伙涉嫌开办23个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXO5Gp.html" rel="bookmark" class="title">请教提高数据传输速度方案</a>
					<div>
						问题描述 我做一个webservice接口,定义用户传送数据流,我来进行保存,对速度有要求在万兆网络达到100MB/S现在模拟一个接口做成webservice发布出来trasferdata(byte[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAj0KM.html" rel="bookmark" class="title">eclipse不打logcat日志怎么办？</a>
					<div>
						问题描述 eclipse不打logcat日志怎么办? 解决方案 Eclipse中LogCat不刷新怎么办Coolpad在Eclipse不输出LogCat日志eclipse无法打印logcat日志 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKlL6b.html" rel="bookmark" class="title">word-C&num;导出Word时去掉下划线</a>
					<div>
						问题描述 C#导出Word时去掉下划线 因为我在导出Word时用的是一个对象,所以在我给一段文字设置了下划线以后接下来所有的文字都有了下划线,该怎么取消掉他的下划线 解决方案 导出Word?你是要在W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGENDlM.html" rel="bookmark" class="title">腾讯起诉360案延期审理部分用户欲起诉腾讯</a>
					<div>
						360起诉腾讯侵犯名誉权案也已被法院受理 本报讯 (记者 索冬冬)原定于昨日开庭审理的腾讯起诉360不正当竞争案,临时取消开庭延期审理,开庭时间未定.有知情人士透露,推迟开庭的原因在于360公司认为举 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z405aYz.html" rel="bookmark" class="title">两分钟了解网络犯罪服务平台那些不为人知的服务</a>
					<div>
						本文讲的是两分钟了解网络犯罪服务平台那些不为人知的服务,目前,越来越多的网络犯罪被商业化,并且通过出租黑客工具和技术,从漏洞套件到ransomware,帮助人们构建威胁并发起攻击,即使它前身就是大型企 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmqO8M.html" rel="bookmark" class="title">请问photoshop与coredraw两个工具绘图有什么差别，功能哪个现加强大？</a>
					<div>
						问题描述 请问photoshop与coredraw两个工具绘图有什么差别,功能哪个现加强大? 感觉都能绘图,差别应该不大吧.但是美工一般同时装这两个软件它们之间有什么不同的功能吗? 解决方案 国内的印 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqXKLz.html" rel="bookmark" class="title">Qt之窗体透明</a>
					<div>
						简述 关于窗体透明,经常遇到,下面我们针对常用的透明效果进行讲解: 全透明(主窗体.子窗体均透明) 主窗体透明(子窗体不透明) 子窗体透明(主窗体不透明) 简述 正常状态 全透明 效果 源码 主窗体透 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKk1Az.html" rel="bookmark" class="title">jQuery轮播图效果精简版完整示例&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery轮播图效果.分享给大家供大家参考,具体如下: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitiona ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0gdYM.html" rel="bookmark" class="title">总结2007年的新名词SEO（搜索引擎优化）</a>
					<div>
						2007年,做网站的站长们基本上都在运用SEO技术对自己的网站进行优化,只是欠缺的经验和对百度.Google的算法认知程度,于是,各类SEO软件.SEO教程.SEO服务层出不穷.   先来说说SEO的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RqGAz.html" rel="bookmark" class="title">世界上没有完美的编程语言， 不要和一种语言厮守终生</a>
					<div>
						简评:就像段子中说的那样,如果你想爆发一场程序员之间的世界大战,只需要发一句&quot;PHP是最好的语言&quot;就可以了.其实对于程序员而言,往往喜欢给自己打上&quot;Java程序员&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0GXrz.html" rel="bookmark" class="title">大数据时代 开源商业化&mdash;&mdash;机遇与责任并存</a>
					<div>
						围追堵截--昔日微软对开源痛下杀手 1984年,Richard Stallman 发起GNU和Free SoftwareFoundation,至今,开源已经有28年的历史.从最底层的操作系统到高级ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZRLkb.html" rel="bookmark" class="title">Ajax PHP JavaScript MySQL实现简易无刷新在线聊天室&lowbar;php实例</a>
					<div>
						为更好的运用这两天学到的Ajax的相关的知识,就做了个简单的在线网络聊天室. 思路 实现聊天室,基本上就是通过Ajax来传递数据,让PHP来实现对数据的差入和查找,再交给前端JavaScript实现页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0xDrz.html" rel="bookmark" class="title">使用新浪微博API的OAuth认证发布微博实例&lowbar;php实例</a>
					<div>
						继续前面的文章&lt;新浪微博OAuth认证和储存的主要过程详解&gt;,现在我们就使用它来发布微博. 我们已经将用户新浪微博的oauth_token和oauth_secret保存到 $_SESSIO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2JkvM.html" rel="bookmark" class="title">mysql 触发器的 like 语句</a>
					<div>
						问题描述 mysql 触发器的 like 语句 语句执行之后触发器没有执行 like语句该怎么写?????????? 解决方案 like concat(old.c_id,'%');					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ181ob.html" rel="bookmark" class="title">ios-今天提交的时候报&amp;amp&semi;amp&semi;quot&semi;missing or invalid signature&amp;amp&semi;amp&semi;quot&semi;错，请教怎么办？</a>
					<div>
						问题描述 今天提交的时候报&quot;missing or invalid signature&quot;错,请教怎么办? 解决方案 说明证书签名错误,检查下你的签名或者证书是否有效. 解决方案二:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1kaBb.html" rel="bookmark" class="title">利用Revit api能改变柱子的loaction吗</a>
					<div>
						问题描述 我想实现一个墙柱对齐的功能,就是根据墙的边将柱子的指定边移动到墙的边.想知道如何改变柱子的loaction来进行移动.谢谢高手.. 解决方案 解决方案二:autocad现在也支持c#了解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9N1l3p.html" rel="bookmark" class="title">智能视频分析，视频监控新的标准应用</a>
					<div>
						毋庸置疑,过去的五年是视频监控产品和市场飞速发展的五年. 随着高清摄像机的普及, 用户的视觉应用体验得到质的飞跃.IP和IT技术的广泛引入,视频监控应用的地域限制被彻底地打破,类似的极具现场即视感的视 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7w2jqz.html" rel="bookmark" class="title">Ubuntu 17&period;10新功能抢先看</a>
					<div>
						距离Ubuntu 17.10发布还有2个月左右,在正式版发布之前,让我们来看看新版系统带来哪些新特性: 一.桌面环境 Ubuntu 17.10将把默认的Unity桌面换成Gnome桌面环境,最后一个b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0OmLM.html" rel="bookmark" class="title">黑客入侵Windows XP系统常用七大招数&lowbar;安全相关</a>
					<div>
						本文讲述了黑客入侵Windows XP操作系统常用的七种方法,如果大家遇到类似那可要注意了--  第一招:屏幕保护 在Windows中启用了屏幕保护之后,只要我们离开计算机(或者不操作计算机)的时间达 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
